//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.
import { Variable } from "./Variable.js";
import { LivePropertyEvent } from "./LivePropertyEvent.js";
//import { typeOfValue } from "../index.js";
import { printClass } from "./printClass.js";
export class LiveProperty {
    //**********************************************************************
    // Constructors and Finalizer
    //**********************************************************************
    constructor(control, tag, prototype, interactive) {
        this.variable = null; // Active value																	// omkar note: changed this to public to access in controlslider method to overcome some error.
        this.inFocus = true;
        this.inEdit = true;
        //if(printClass.printStatus) console.log("I am in constructor method of LiveProperty with tag: " + tag );
        this.control = control;
        this.tag = tag;
        this.prototype = prototype;
        if (interactive != undefined) {
            this.interactive = interactive;
        }
        else {
            this.interactive = false;
        }
        //if(printClass.printStatus) console.log("I am in end of constructor method of LiveProperty");
        this.listeners = [];
        //if(printClass.printStatus) console.log(this.status);
    }
    //**********************************************************************
    // Getters and Setters
    //**********************************************************************
    getControl() {
        return this.control;
    }
    getTag() {
        return this.tag;
    }
    getPrototype() {
        return this.prototype;
    }
    getInteractive() {
        return this.interactive;
    }
    getVariable() {
        return this.variable;
    }
    setVariable(variable) {
        if (printClass.printStatus)
            console.log("setVariable Method of LiveProperty");
        //printClass.myprint(variable); 
        if (printClass.printStatus)
            console.log(variable);
        if (this.variable == variable)
            return;
        if (printClass.printStatus)
            console.log("LiveProperty: Did i reach here on setVariable");
        if (printClass.printStatus)
            console.log(variable.getPrototype().value);
        if (printClass.printStatus)
            console.log(Object.getPrototypeOf(variable.getPrototype().value));
        //if ((variable != null) &&  !(variable.getPrototype()).isInstance(LiveProperty.prototype))
        if ((variable != null) && !(Object.getPrototypeOf(variable.getPrototype().value) == Object.getPrototypeOf(this.prototype.value))) {
            throw new Error("\nType mismatch:" + "\n" + this.prototype + "\n" + variable.getPrototype());
        }
        if (printClass.printStatus)
            console.log("Hello");
        if (this.variable != null) {
            if (this.inFocus)
                this.variable.setFocusing(false, this);
            if (this.inEdit)
                this.variable.setEditing(false, this);
            this.variable.removeVariableListener(this);
        }
        this.variable = variable;
        if (printClass.printStatus)
            console.log(variable);
        //*********************************************************************************************
        if (this.variable != null) {
            variable.addVariableListener(this);
            if (this.inFocus)
                this.variable.setFocusing(true, this);
            if (this.inEdit)
                this.variable.setEditing(true, this);
        }
        //console.log("LiveProperty: Did i reach here on setVariable");
        //this.fireEvent(new LivePropertyEvent(this, null));
        this.firePropertyChanged(new LivePropertyEvent(this, null));
    }
    //**********************************************************************
    // Public Methods
    //**********************************************************************
    getType() {
        return this.prototype.getType;
    }
    getName() {
        if (this.variable == null)
            return this.prototype.getName;
        else
            return this.variable.getName();
    }
    setName(name) {
        if (name == null)
            name = this.prototype.getName;
        if (this.variable != null)
            this.variable.setName(name);
    }
    getValue() {
        if (this.variable == null)
            return this.prototype.getValue();
        else
            return this.variable.getValue();
    }
    setValue(value) {
        //console.log(value);
        if (printClass.printStatus)
            console.log("setValue of LiveProperty");
        //if(printClass.printStatus) console.log(value);
        if (printClass.printStatus)
            console.log('SetValue in LiveProperty');
        if (value == null) {
            console.log("Object is null");
            value = this.prototype.getValue();
        }
        //if(printClass.printStatus) console.log(object);	
        if (this.variable != null)
            this.variable.setValue(value);
    }
    touch() {
        if (this.variable != null)
            this.variable.touch();
    }
    //**********************************************************************
    // Public Methods (Locking)
    //**********************************************************************
    isLocked() {
        return ((this.variable == null) || this.variable.isLocked());
    }
    //**********************************************************************
    // Public Methods (Focusing)
    //**********************************************************************
    isFocusing() {
        //return (inFocus || ((variable != null) && variable.isFocusing()));
        if (this.variable == null)
            return this.inFocus;
        else
            return this.variable.isFocusing();
    }
    setFocusing(b) {
        if (this.inFocus == b)
            return;
        this.inFocus = b;
        if (this.variable != null)
            this.variable.setFocusing(this.inFocus, this);
    }
    //**********************************************************************
    // Public Methods (Editing)
    //**********************************************************************
    isEditing() {
        //return (inEdit || ((variable != null) && variable.isEditing()));
        if (this.variable == null)
            return this.inEdit;
        else
            return this.variable.isEditing();
    }
    setEditing(b) {
        if (this.inEdit == b)
            return;
        this.inEdit = b;
        if (this.variable != null)
            this.variable.setEditing(this.inEdit, this);
    }
    //**********************************************************************
    // Public Methods (Events)
    //**********************************************************************
    addLivePropertyListener(l) {
        if (printClass.printStatus)
            console.log(l.toString());
        if (printClass.printStatus)
            console.log(l);
        this.listeners.push(l);
    }
    removeLivePropertyListener(l) {
        this.listeners.splice(this.listeners.indexOf(l), 1);
    }
    //**********************************************************************
    // Override Methods (Disposable)
    //**********************************************************************
    dispose() {
        if (this.variable != null) {
            if (this.inFocus)
                this.variable.setFocusing(false, this);
            if (this.inEdit)
                this.variable.setEditing(false, this);
            this.variable.removeVariableListener(this);
            this.variable.dispose;
        }
    }
    //**********************************************************************
    // Override Methods (VariableListener)
    //**********************************************************************
    variableChanged(e) {
        if (printClass.printStatus)
            console.log(" variableChanged method of liveProperty ");
        this.fireEvent(new LivePropertyEvent(this, e));
    }
    //**********************************************************************
    // Private Methods (Events)
    //**********************************************************************
    fireEvent(e) {
        if (Variable.STARTUP) {
            var ve = e.getVariableEvent();
            if (ve != null)
                return;
        }
        this.firePropertyChanged(e);
    }
    firePropertyChanged(e) {
        if (printClass.printStatus)
            console.log("firePropertyChanged of LiveProperty");
        var n = this.listeners.length;
        var i;
        for (i = 0; i < n; i++) {
            if (printClass.printStatus)
                console.log(this.listeners[i]);
        }
        if (printClass.printStatus)
            console.log("Number of Listeners:" + n);
        if (printClass.printStatus)
            console.log(e);
        //if(printClass.printStatus) console.log(this.status);
        for (i = 0; i < n; i++) {
            if (printClass.printStatus)
                console.log("Listener :" + i);
            if (printClass.printStatus)
                console.log(this.listeners[i]); //not working
            this.listeners[i].propertyChanged(e);
        }
    }
}
//# sourceMappingURL=LiveProperty.js.map