//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.
// This file is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
// details.
// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
import { Prototype } from "../LP/Prototype.js";
import { ControlProxy } from "../LP/ControlProxy.js";
//import { typeOfValue } from "../index.js";
import { printClass } from "../LP/printClass.js";
import { ScatterplotClass } from "../view/scatterplot.js";
//******************************************************************************
// class ControlSlider
//******************************************************************************
export class ControlScatterplot {
    //**********************************************************************
    // Constructors and Finalizer
    //**********************************************************************
    constructor(name, data, xPos, yPos, horizontal, vertical, inputWidth, inputHeight, showHoriz, showVerti, helper, color, size, text) {
        this.CTAG_xTranslate = "xTranslate";
        this.CTAG_yTranslate = "yTranslate";
        this.CTAG_Size = "Size";
        this.CTAG_Opacity = "Opacity";
        this.CTAG_Selection = "Selection";
        this.CTAG_Indication = "Indication";
        this.CTAG_Data = "Data";
        this.CTAG_Zoom = "Zoom";
        this.CTAG_xRange = "xRange";
        this.CTAG_yRange = "yRange";
        this.CTAG_brushX = "brushX";
        this.CTAG_brushY = "brushY";
        this.TYPE_xTranslate = new Prototype(Array.prototype, this.CTAG_xTranslate, [null, null]);
        this.TYPE_yTranslate = new Prototype(Array.prototype, this.CTAG_yTranslate, [null, null]);
        this.TYPE_Size = new Prototype(Number.prototype, this.CTAG_Size, 0);
        this.TYPE_Opacity = new Prototype(Number.prototype, this.CTAG_Opacity, 0);
        this.TYPE_Selection = new Prototype(Array.prototype, this.CTAG_Selection, [false]);
        this.TYPE_Indication = new Prototype(Array.prototype, this.CTAG_Indication, [false]);
        this.TYPE_Data = new Prototype(Array.prototype, this.CTAG_Data, []);
        this.TYPE_Zoom = new Prototype(Array.prototype, this.CTAG_Zoom, [null, null]);
        this.TYPE_xRange = new Prototype(Array.prototype, this.CTAG_xRange, [null, null]);
        this.TYPE_yRange = new Prototype(Array.prototype, this.CTAG_yRange, [null, null]);
        this.TYPE_brushX = new Prototype(Array.prototype, this.CTAG_brushX, [null, null]);
        this.TYPE_brushY = new Prototype(Array.prototype, this.CTAG_brushY, [null, null]);
        if (printClass.printStatus)
            console.log("I am in constructor of ControlScatterplot");
        //Create Control Proxy
        //if(printClass.printStatus) console.log(this.TYPE_VALUE);
        this.proxy = new ControlProxy(this);
        //create live property
        this.live_property_xTranslate = this.proxy.add(this.CTAG_xTranslate, this.TYPE_xTranslate, true);
        this.live_property_yTranslate = this.proxy.add(this.CTAG_yTranslate, this.TYPE_yTranslate, true);
        this.live_property_Opacity = this.proxy.add(this.CTAG_Opacity, this.TYPE_Opacity, true);
        this.live_property_Selection = this.proxy.add(this.CTAG_Selection, this.TYPE_Selection, true);
        this.live_property_Indication = this.proxy.add(this.CTAG_Indication, this.TYPE_Indication, true);
        this.live_property_Size = this.proxy.add(this.CTAG_Size, this.TYPE_Size, true);
        this.live_property_Data = this.proxy.add(this.CTAG_Data, this.TYPE_Data, true);
        this.live_property_Zoom = this.proxy.add(this.CTAG_Zoom, this.TYPE_Zoom, true);
        this.live_property_xRange = this.proxy.add(this.CTAG_xRange, this.TYPE_xRange, true);
        this.live_property_yRange = this.proxy.add(this.CTAG_yRange, this.TYPE_yRange, true);
        this.live_property_brushX = this.proxy.add(this.CTAG_brushX, this.TYPE_brushX, true);
        this.live_property_brushY = this.proxy.add(this.CTAG_brushY, this.TYPE_brushY, true);
        this.ControlName = name;
        //console.log(data)
        this.scatterplot = new ScatterplotClass(this, data, name, xPos, yPos, horizontal, vertical, inputWidth, inputHeight, showHoriz, showVerti, helper, color, size, text);
        if (printClass.printStatus)
            console.log(name);
    }
    //**********************************************************************
    // Public Methods (Properties)
    //**********************************************************************
    getTranslateX() {
        return this.proxy.getValue(this.CTAG_xTranslate);
    }
    setTranslateX(value) {
        console.log("setTranslateX method of ControlScatterplot");
        this.proxy.setValue(this.CTAG_xTranslate, value);
        //this.canvas.setValue(value);
    }
    getColor() {
        return this.proxy.getValue(this.CTAG_Opacity);
    }
    getProxy() {
        return this.proxy;
    }
    setColor(value) {
        if (printClass.printStatus)
            console.log("setColor method of ControlScatterplot");
        this.proxy.setValue(this.CTAG_Opacity, value);
        //this.canvas.setValue(value);
    }
    getTranslateY() {
        return this.proxy.getValue(this.CTAG_yTranslate);
    }
    setTranslateY(value) {
        console.log("setTranslateY method of ControlScatterplot");
        this.proxy.setValue(this.CTAG_yTranslate, value);
        //this.canvas.setValue(value);
    }
    //**********************************************************************
    // Override Methods (LivePropertyListener)
    //**********************************************************************
    propertyChanged(e) {
        if (printClass.printStatus)
            console.log("propertyChanged method of controlScatterPlot");
        if (printClass.printStatus)
            console.log(e);
        var tag = e.getLiveProperty().getTag();
        if (printClass.printStatus)
            console.log(tag);
        var ve = e.getVariableEvent();
        if (tag == this.CTAG_xTranslate) {
            if (printClass.printStatus)
                console.log("Property Changed controlScatterPlot height");
            this.scatterplot.translateX(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_yTranslate) {
            if (printClass.printStatus)
                console.log("Property Changed controlScatterPlot Width");
            this.scatterplot.translateY(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_Opacity) {
            if (printClass.printStatus)
                console.log("Property Changed controlScatterPlot opacity");
            this.scatterplot.setOpacity(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_Selection) {
            if (printClass.printStatus)
                console.log("Property Changed ControlScatterplot Selection");
            this.scatterplot.setSelection(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_Indication) {
            if (printClass.printStatus)
                console.log("Property Changed ControlScatterplot Indication");
            this.scatterplot.setIndication(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_Size) {
            if (printClass.printStatus)
                console.log("Property Changed ControlScatterplot Size");
            this.scatterplot.setSize(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_Data) {
            if (printClass.printStatus)
                console.log("Property Changed ControlScatterplot Size");
            this.scatterplot.setHoverSelection(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_Zoom) {
            if (printClass.printStatus)
                console.log("Property Changed ControlScatterplot Zoom");
            this.scatterplot.setZoom(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_xRange) {
            if (printClass.printStatus)
                console.log("Property Changed ControlScatterplot xRange");
            this.scatterplot.setxRange(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_yRange) {
            if (printClass.printStatus)
                console.log("Property Changed ControlScatterplot yRange");
            this.scatterplot.setyRange(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_brushX) {
            if (printClass.printStatus)
                console.log("Property Changed ControlScatterplot brushX");
            this.scatterplot.setBrushX(e.getLiveProperty().getVariable().getValue());
        }
        else if (tag == this.CTAG_brushY) {
            if (printClass.printStatus)
                console.log("Property Changed ControlScatterplot brushY");
            this.scatterplot.setBrushY(e.getLiveProperty().getVariable().getValue());
        }
    }
    //**********************************************************************
    // Private Methods (Graphics)
    //**********************************************************************
    describe() {
        throw new Error("Method not implemented.");
    }
    dispose() {
        throw new Error("Method not implemented.");
    }
}
//******************************************************************************
//# sourceMappingURL=ControlScatterplot.js.map