//   C4D3 is free software: you can redistribute it and/or modify it under
// the terms of the GNU Affero General Public License as published by the Free
// Software Foundation, either version 3 of the License, or (at your option) any
// later version.

// This file is distributed in the hope that it will be useful, but WITHOUT
// ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
// details.

// You should have received a copy of the GNU Affero General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.

type Callback = () => void;

export class Eventing{
    events: { [key: string]: Callback[] } = {};

    on(eventName: string, callback: Callback): void
    {
        const handlers = this.events[eventName] || [];
        handlers.push(callback);

        this.events[eventName] = handlers;
    }



    /* trigger(value: number): void
    {
        this.slider.setValue = value;
    } */



    trigger(eventName:string):void{
               const handlers = this.events[eventName];
       
               if(!handlers||handlers.length===0){
                   return;
               }
       
               handlers.forEach(callback =>{
                   callback()
               });
           }


}